#include "mpdimpl.h"

BOOL RunRead(MPD_Context *p, int *pRunReturn)
{
    int ret_val;
    int error;
    sockaddr addr;
#ifdef USE_LINGER_SOCKOPT
    struct linger linger;
#endif
    int len;
    int bfd;
    BOOL b;
    MPD_Context *e;

    switch(p->nType)
    {
    case MPD_SOCKET:
    case MPD_LEFT_SOCKET:
    case MPD_RIGHT_SOCKET:
    case MPD_CONSOLE_SOCKET:
	p->nState = MPD_READING;
	/*
	ret_val = bread(p->bfd, &p->pszIn[p->nCurPos], 1);
	if (ret_val == 1)
	{
	    while (ret_val == 1)
	    {
		if (p->pszIn[p->nCurPos] == '\0')
		{
		    p->nState = MPD_IDLE;
		    p->nCurPos = 0;
		    StringRead(p);
		    break;
		}
		else
		{
		    p->nCurPos++;
		}
		ret_val = bread(p->bfd, &p->pszIn[p->nCurPos], 1);
	    }
	}
	else
	    */
	if (ReadString(p->bfd, p->pszIn))
	{
	    p->nState = MPD_IDLE;
	    p->nCurPos = 0;
	    StringRead(p);
	}
	else
	{
	    error = WSAGetLastError();
	    char *pszSocket;
	    switch (p->nType)
	    {
	    case MPD_LEFT_SOCKET:
		pszSocket = "MPD_LEFT_SOCKET";
		break;
	    case MPD_RIGHT_SOCKET:
		pszSocket = "MPD_RIGHT_SOCKET";
		break;
	    case MPD_CONSOLE_SOCKET:
		pszSocket = "MPD_CONSOLE_SOCKET";
		break;
	    default:
		pszSocket = "MPD_SOCKET";
		break;
	    }
	    err_printf("RunRead: ReadString failed for socket 0x%p:%d\n", p->bfd, bget_fd(p->bfd));
	    /*
	    if (ret_val == SOCKET_ERROR)
	    {
		err_printf("Run: bread failed for %s(%d:%d), error %d\n", pszSocket, p->bfd, bget_fd(p->bfd), error);
	    }
	    else if (ret_val == 0)
	    {
		err_printf("Run: %s %d unexpectedly closed\n", pszSocket, p->bfd);
	    }
	    else
	    {
		err_printf("Run: bread on %s returned unknown value, %d\n", pszSocket, ret_val);
	    }
	    */
	    p->bDeleteMe = true;
	    p->nState = MPD_INVALID;
	}
	break;
    case MPD_LISTENER:
	len = sizeof(addr);
	bfd = baccept(p->bfd, &addr, &len);
	if (bfd == BFD_INVALID_SOCKET)
	{
	    int error = WSAGetLastError();
	    err_printf("RunRead: baccept failed: %d\n", error);
	    break;
	}
	dbg_printf("listener[%s] accepted new connection bfd[%s]\n", bto_string(p->bfd), bto_string(bfd));
#ifdef USE_LINGER_SOCKOPT
	linger.l_onoff = 1;
	linger.l_linger = 60;
	if (bsetsockopt(bfd, SOL_SOCKET, SO_LINGER, (char*)&linger, sizeof(linger)) == SOCKET_ERROR)
	{
	    int error = WSAGetLastError();
	    err_printf("RunRead: bsetsockopt failed: %d\n", error);
	    beasy_closesocket(bfd);
	    bfd = BFD_INVALID_SOCKET;
	    break;
	}
#endif
	b = TRUE;
	bsetsockopt(bfd, IPPROTO_TCP, TCP_NODELAY, (char*)&b, sizeof(BOOL));
	if ((g_nActiveR >= FD_SETSIZE - 3) || (g_nActiveW >= FD_SETSIZE - 3))
	{
	    // No more sockets available
	    err_printf("RunRead: !!!!!!!!No sockets available, incoming connect rejected!!!!!!!\n");
	    beasy_closesocket(bfd);
	    bfd = BFD_INVALID_SOCKET;
	}
	else
	{
	    e = new MPD_Context;
	    e->bfd = bfd;
	    e->nCurPos = 0;
	    e->nState = MPD_IDLE;
	    e->nLLState = MPD_AUTHENTICATE_WRITING_APPEND;
	    e->nType = MPD_SOCKET;
	    e->pNext = g_pList;
	    g_pList = e;
	    g_maxfds = BFD_MAX(bfd, g_maxfds);
	    DoReadSet(bfd);
	    AuthenticateConnection(e);
	    /*
	    DoWriteSet(bfd);
	    if (!GenAuthenticationStrings(e->pszOut, e->pszCrypt))
	    {
		err_printf("RunRead: failed to generate the authentication strings\n");
		RemoveContext(e);
	    }
	    EnqueueWrite(e, NULL, MPD_AUTHENTICATE_WRITING_APPEND);
	    */
	}
	break;
    case MPD_SIGNALLER:
	dbg_printf("read available on signal socket %d ... ", p->bfd);
	ret_val = beasy_receive(p->bfd, p->pszIn, 1);
	
	if (ret_val == SOCKET_ERROR)
	{
	    // If we lose the signaller, we cannot stop the service.
	    // So, shut down here and abort.
	    err_printf("RunRead: signaller socket failed, error %d\n", WSAGetLastError());
	    ShutdownAllProcesses();
	    AbortAllForwarders();
	    RemoveAllTmpFiles();
	    FinalizeDriveMaps();
	    dbg_printf("exiting\n");
	    //return RUN_RESTART;
	    *pRunReturn = RUN_RESTART;
	    return FALSE;
	}
	
	if (g_nSignalCount)
	{
	    dbg_printf("extracting\n");
	    if (!Extract(false))
	    {
		// If we cannot start the extraction process, just exit
		ShutdownAllProcesses();
		AbortAllForwarders();
		RemoveAllTmpFiles();
		FinalizeDriveMaps();
		warning_printf("mpd exiting without extracting itself from the ring\n");
		//return RUN_EXIT;
		*pRunReturn = RUN_EXIT;
		return FALSE;
	    }
	}
	else
	{
	    ShutdownAllProcesses();
	    AbortAllForwarders();
	    RemoveAllTmpFiles();
	    FinalizeDriveMaps();
	    dbg_printf("exiting\n");
	    //return RUN_EXIT;
	    *pRunReturn = RUN_EXIT;
	    return FALSE;
	}
	break;
    case MPD_RESELECTOR:
	if (beasy_receive(p->bfd, p->pszIn, 1) == SOCKET_ERROR)
	{
	    err_printf("RunRead: reselector socket failed, error %d\n", WSAGetLastError());
	    ShutdownAllProcesses();
	    AbortAllForwarders();
	    RemoveAllTmpFiles();
	    FinalizeDriveMaps();
	    dbg_printf("exiting\n");
	    //return RUN_RESTART;
	    *pRunReturn = RUN_RESTART;
	    return FALSE;
	}
	break;
    default:
	err_printf("RunRead: Error, read available on socket %d of unknown type %d\n", p->bfd, p->nType);
	break;
    }
    return TRUE;
}

BOOL RunWrite(MPD_Context *p, int *pRunReturn)
{
    int error;

    switch(p->nType)
    {
    case MPD_SOCKET:
    case MPD_LEFT_SOCKET:
    case MPD_RIGHT_SOCKET:
    case MPD_CONSOLE_SOCKET:
	p->nState = MPD_WRITING;
	do 
	{
	    if (WriteString(p->bfd, p->pszOut) != SOCKET_ERROR)
	    {
		if (p->pWriteList == NULL)
		    p->nState = MPD_IDLE;
		p->nCurPos = 0;
		StringWritten(p);
	    }
	    else
	    {
		error = WSAGetLastError();
		char *pszSocket;
		switch (p->nType)
		{
		case MPD_LEFT_SOCKET:
		    pszSocket = "MPD_LEFT_SOCKET";
		    break;
		case MPD_RIGHT_SOCKET:
		    pszSocket = "MPD_RIGHT_SOCKET";
		    break;
		case MPD_CONSOLE_SOCKET:
		    pszSocket = "MPD_CONSOLE_SOCKET";
		    break;
		default:
		    pszSocket = "MPD_SOCKET";
		    break;
		}
		err_printf("RunWrite: WriteString failed for socket 0x%p:%d\n", p->bfd, bget_fd(p->bfd));
		p->nState = MPD_INVALID;
		p->bDeleteMe = true;
	    }
	} while (p->nState == MPD_WRITING);
	break;
    case MPD_LISTENER:
	err_printf("RunWrite: Error, write available on listener socket %d\n", p->bfd);
	break;
    case MPD_SIGNALLER:
	err_printf("RunWrite: Error, write available on signal socket %d\n", p->bfd);
	break;
    default:
	err_printf("RunWrite: Error, write available on socket %d of unknown type %d\n", p->bfd, p->nType);
	break;
    }
    return TRUE;
}

// Run ///////////////////////////////////////////////////////////////////////
//
//
int Run()
{
    int n;
    MPD_Context *p, *pNext;
    bfd_set read_set;
    int ret_val;
    int error;
    int bfdWriteAvailable;
    char ch;

    MakeLoop(&bfdWriteAvailable, &g_bfdWriteSignal);
    DoReadSet(bfdWriteAvailable);

    while(true)
    {
	read_set = g_ReadSet;

	dbg_printf("Run:bselect...\n");
	dbg_printf("read_set: ");
	bprint_set(&g_ReadSet);

	n = bselect(g_maxfds, &read_set, NULL, NULL, NULL);
	if (n == SOCKET_ERROR)
	{
	    error = WSAGetLastError();
	    err_printf("Run: bselect failed, error %d\n", error);
	    return RUN_RESTART;
	}
	if (n == 0)
	{
	    err_printf("Run: bselect returned zero sockets available\n");
	    return RUN_RESTART;
	}

	if (BFD_ISSET(bfdWriteAvailable, &read_set))
	{
	    beasy_receive(bfdWriteAvailable, &ch, 1);
	    dbg_printf("Run: write available\n");
	    n--;
	}

	// check for reads
	p = g_pList;
	while (n)
	{
	    if (!p)
	    {
		err_printf("Run: n(%d) arbitrarily set to zero because p == NULL\n", n);
		n = 0;
		break;
	    }

	    pNext = p->pNext;

	    if (p->nState == MPD_INVALID)
	    {
		if (BFD_ISSET(p->bfd, &read_set))
		{
		    err_printf("Run: read available on invalid bfd[%s]\n", bto_string(p->bfd));
		    n--;
		}
	    }
	    else
	    {
		if (BFD_ISSET(p->bfd, &read_set))
		{
		    if (!RunRead(p, &ret_val))
			return ret_val;
		    n--;
		}
	    }

	    if (p->bDeleteMe)
		RemoveContext(p);
	    p = pNext;
	}

	// check for writes
	p = g_pList;
	while (p)
	{
	    pNext = p->pNext;

	    if (p->nState == MPD_WRITING)
	    {
		if (!RunWrite(p, &ret_val))
		    return ret_val;
	    }

	    if (p->bDeleteMe)
		RemoveContext(p);
	    p = pNext;
	}
    }

    return RUN_EXIT;
}
/*
int Run()
{
    int n;
    MPD_Context *p, *pNext;
    bfd_set read_set, write_set;
    int ret_val;
    int error;

    while(true)
    {
	read_set = g_ReadSet;
	write_set = g_WriteSet;

	dbg_printf("Run:bselect...\n");
	dbg_printf("read_set:\n");
	bprint_set(&g_ReadSet);
	dbg_printf("write_set:\n");
	bprint_set(&g_WriteSet);
	n = bselect(g_maxfds, &read_set, &write_set, NULL, NULL);
	if (n == SOCKET_ERROR)
	{
	    error = WSAGetLastError();
	    err_printf("Run: bselect failed, error %d\n", error);
	    return RUN_RESTART;
	}
	if (n == 0)
	{
	    err_printf("Run: bselect returned zero sockets available\n");
	    return RUN_RESTART;
	}

	p = g_pList;
	while (n)
	{
	    if (!p)
	    {
		err_printf("Run: n(%d) arbitrarily set to zero because p == NULL\n", n);
		n = 0;
		break;
	    }

	    pNext = p->pNext;

	    if (p->nState == MPD_INVALID)
	    {
		if (BFD_ISSET(p->bfd, &read_set))
		{
		    err_printf("Run: read available on invalid bfd[%s]\n", bto_string(p->bfd));
		    n--;
		}
		if (BFD_ISSET(p->bfd, &write_set))
		{
		    err_printf("Run: write available on invalid bfd[%s]\n", bto_string(p->bfd));
		    n--;
		}
	    }
	    else
	    {
		if (BFD_ISSET(p->bfd, &read_set))
		{
		    if (!RunRead(p, &ret_val))
			return ret_val;
		    n--;
		}
		
		if (BFD_ISSET(p->bfd, &write_set))
		{
		    if (!RunWrite(p, &ret_val))
			return ret_val;
		    n--;
		}
	    }

	    if (p->bDeleteMe)
		RemoveContext(p);
	    p = pNext;
	}
    }

    return RUN_EXIT;
}
*/
