#include "mpdutil.h"
#include "bsocket.h"
#include "mpd.h"

#define err_printf printf

bool ReadStringMax(int bfd, char *str, int max)
{
    int n;
    char *str_orig = str;
    int count = 0;

    //dbg_printf("reading from %d\n", bget_fd(bfd));
    do {
	/*
	n = 0;
	while (!n)
	{
	    n = bread(bfd, str, 1);
	    if (n == SOCKET_ERROR)
	    {
		err_printf("ReadString[%d] failed, error %d\n", bget_fd(bfd), WSAGetLastError());
		return false;
	    }
	}
	*/
	n = beasy_receive(bfd, str, 1);
	if (n == SOCKET_ERROR)
	{
	    err_printf("ReadString[%d] failed, error %d\n", bget_fd(bfd), WSAGetLastError());
	    return false;
	}
	if (n == 0)
	{
	    err_printf("ReadString[%d] failed, socket closed\n", bget_fd(bfd));
	    return false;
	}
	count++;
	if (count == max && *str != '\0')
	{
	    *str = '\0';
	    // truncate, read and discard all further characters of the string
	    char ch;
	    do {
		/*
		n = 0;
		while (!n)
		{
		    n = bread(bfd, &ch, 1);
		    if (n == SOCKET_ERROR)
		    {
			err_printf("ReadString[%d] failed, error %d\n", bget_fd(bfd), WSAGetLastError());
			return false;
		    }
		}
		*/
		n = beasy_receive(bfd, &ch, 1);
		if (n == SOCKET_ERROR)
		{
		    err_printf("ReadString[%d] failed, error %d\n", bget_fd(bfd), WSAGetLastError());
		    return false;
		}
		if (n == 0)
		{
		    err_printf("ReadString[%d] failed, socket closed\n", bget_fd(bfd));
		    return false;
		}
	    } while (ch != '\0');
	}
    } while (*str++ != '\0');
    //dbg_printf("RSM(%s) '%s'\n", bto_string(bfd), str_orig);
    //dbg_printf_color(FOREGROUND_RED | FOREGROUND_INTENSITY, "RSM(%s) '%s'\n", bto_string(bfd), str_orig);
    //return strlen(str_orig);
    return true;
}

bool ReadString(int bfd, char *str)
{
    int n;
    char *str_orig = str;

    //dbg_printf("reading from %d\n", bget_fd(bfd));
    do {
	/*
	n = 0;
	while (!n)
	{
	    n = bread(bfd, str, 1);
	    if (n == SOCKET_ERROR)
	    {
		err_printf("ReadString[%d] failed, error %d\n", bget_fd(bfd), WSAGetLastError());
		return false;
	    }
	}
	*/
	n = beasy_receive(bfd, str, 1);
	if (n == SOCKET_ERROR)
	{
	    err_printf("ReadString[%d] failed, error %d\n", bget_fd(bfd), WSAGetLastError());
	    return false;
	}
	if (n == 0)
	{
	    err_printf("ReadString[%d] failed, socket closed\n", bget_fd(bfd));
	    return false;
	}
    } while (*str++ != '\0');
    //dbg_printf("RS (%s) '%s'\n", bto_string(bfd), str_orig);
    //dbg_printf_color(FOREGROUND_RED | FOREGROUND_INTENSITY, "RS (%s) '%s'\n", bto_string(bfd), str_orig);
    //return strlen(str_orig);
    return true;
}

bool ReadStringTimeout(int bfd, char *str, int timeout)
{
    int n;
    char *str_orig = str;

    //dbg_printf("reading from %d\n", bget_fd(bfd));
    do {
	n = 0;
	while (!n)
	{
	    n = beasy_receive_timeout(bfd, str, 1, timeout);
	    if (n == SOCKET_ERROR)
	    {
		err_printf("ReadStringTimeout failed, error %d\n", WSAGetLastError());
		return false;
	    }
	    if (n == 0)
		return false;
	}
    } while (*str++ != '\0');
    //dbg_printf("RST(%s) '%s'\n", bto_string(bfd), str_orig);
    //dbg_printf_color(FOREGROUND_RED | FOREGROUND_INTENSITY, "RST(%s) '%s'\n", bto_string(bfd), str_orig);
    //return strlen(str_orig);
    return true;
}

int WriteString(int bfd, char *str)
{
    int ret_val;
    if (strlen(str) >= MAX_CMD_LENGTH)
    {
	err_printf("WriteString: command too long, %d\n", strlen(str));
	return SOCKET_ERROR;
    }
    ret_val = beasy_send(bfd, str, strlen(str)+1);
    //dbg_printf("WS (%s), '%s'\n", bto_string(bfd), str);
    /*
    if (ret_val != SOCKET_ERROR)
	dbg_printf_color(FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_INTENSITY, "WS (%s), '%s'\n", bto_string(bfd), str);
    else
	dbg_printf_color(FOREGROUND_RED | FOREGROUND_GREEN, "WS (%s) failed, '%s'\n", bto_string(bfd), str);
	*/
    return ret_val;
}
